Merge branch 'master' of git://repo.or.cz/alt-git
[git/dscho.git] / t / test-lib.sh
blob0949b8e77af3bfe61824e07efa79db768f6753df
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # Keep the original TERM for say_color
7 ORIGINAL_TERM=$TERM
9 # For repeatability, reset the environment to known value.
10 LANG=C
11 LC_ALL=C
12 PAGER=cat
13 TZ=UTC
14 TERM=dumb
15 export LANG LC_ALL PAGER TERM TZ
16 EDITOR=:
17 VISUAL=:
18 unset GIT_EDITOR
19 unset AUTHOR_DATE
20 unset AUTHOR_EMAIL
21 unset AUTHOR_NAME
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
24 unset EMAIL
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26 unset GIT_AUTHOR_DATE
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
32 unset GIT_DIFF_OPTS
33 unset GIT_DIR
34 unset GIT_WORK_TREE
35 unset GIT_EXTERNAL_DIFF
36 unset GIT_INDEX_FILE
37 unset GIT_OBJECT_DIRECTORY
38 unset GIT_CEILING_DIRECTORIES
39 unset SHA1_FILE_DIRECTORIES
40 unset SHA1_FILE_DIRECTORY
41 GIT_MERGE_VERBOSITY=5
42 export GIT_MERGE_VERBOSITY
43 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
45 export EDITOR VISUAL
46 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
48 # Protect ourselves from common misconfiguration to export
49 # CDPATH into the environment
50 unset CDPATH
52 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
53 1|2|true)
54 echo "* warning: Some tests will not work if GIT_TRACE" \
55 "is set as to trace on STDERR ! *"
56 echo "* warning: Please set GIT_TRACE to something" \
57 "other than 1, 2 or true ! *"
59 esac
61 # Each test should start with something like this, after copyright notices:
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
65 # '
66 # . ./test-lib.sh
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68 TERM=$ORIGINAL_TERM &&
69 export TERM &&
70 [ -t 1 ] &&
71 tput bold >/dev/null 2>&1 &&
72 tput setaf 1 >/dev/null 2>&1 &&
73 tput sgr0 >/dev/null 2>&1
74 ) &&
75 color=t
77 while test "$#" -ne 0
79 case "$1" in
80 -d|--d|--de|--deb|--debu|--debug)
81 debug=t; shift ;;
82 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83 immediate=t; shift ;;
84 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85 export GIT_TEST_LONG=t; shift ;;
86 -h|--h|--he|--hel|--help)
87 help=t; shift ;;
88 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89 verbose=t; shift ;;
90 -q|--q|--qu|--qui|--quie|--quiet)
91 quiet=t; shift ;;
92 --no-color)
93 color=; shift ;;
94 --no-python)
95 # noop now...
96 shift ;;
98 break ;;
99 esac
100 done
102 if test -n "$color"; then
103 say_color () {
105 TERM=$ORIGINAL_TERM
106 export TERM
107 case "$1" in
108 error) tput bold; tput setaf 1;; # bold red
109 skip) tput bold; tput setaf 2;; # bold green
110 pass) tput setaf 2;; # green
111 info) tput setaf 3;; # brown
112 *) test -n "$quiet" && return;;
113 esac
114 shift
115 printf "* %s" "$*"
116 tput sgr0
117 echo
120 else
121 say_color() {
122 test -z "$1" && test -n "$quiet" && return
123 shift
124 echo "* $*"
128 error () {
129 say_color error "error: $*"
130 trap - EXIT
131 exit 1
134 say () {
135 say_color info "$*"
138 test "${test_description}" != "" ||
139 error "Test script did not set test_description."
141 if test "$help" = "t"
142 then
143 echo "$test_description"
144 exit 0
147 exec 5>&1
148 if test "$verbose" = "t"
149 then
150 exec 4>&2 3>&1
151 else
152 exec 4>/dev/null 3>/dev/null
155 test_failure=0
156 test_count=0
157 test_fixed=0
158 test_broken=0
159 test_success=0
161 die () {
162 echo >&5 "FATAL: Unexpected exit with code $?"
163 exit 1
166 trap 'die' EXIT
168 # The semantics of the editor variables are that of invoking
169 # sh -c "$EDITOR \"$@\"" files ...
171 # If our trash directory contains shell metacharacters, they will be
172 # interpreted if we just set $EDITOR directly, so do a little dance with
173 # environment variables to work around this.
175 # In particular, quoting isn't enough, as the path may contain the same quote
176 # that we're using.
177 test_set_editor () {
178 FAKE_EDITOR="$1"
179 export FAKE_EDITOR
180 VISUAL='"$FAKE_EDITOR"'
181 export VISUAL
184 test_tick () {
185 if test -z "${test_tick+set}"
186 then
187 test_tick=1112911993
188 else
189 test_tick=$(($test_tick + 60))
191 GIT_COMMITTER_DATE="$test_tick -0700"
192 GIT_AUTHOR_DATE="$test_tick -0700"
193 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
196 # You are not expected to call test_ok_ and test_failure_ directly, use
197 # the text_expect_* functions instead.
199 test_ok_ () {
200 test_count=$(expr "$test_count" + 1)
201 test_success=$(expr "$test_success" + 1)
202 say_color "" " ok $test_count: $@"
205 test_failure_ () {
206 test_count=$(expr "$test_count" + 1)
207 test_failure=$(expr "$test_failure" + 1);
208 say_color error "FAIL $test_count: $1"
209 shift
210 echo "$@" | sed -e 's/^/ /'
211 test "$immediate" = "" || { trap - EXIT; exit 1; }
214 test_known_broken_ok_ () {
215 test_count=$(expr "$test_count" + 1)
216 test_fixed=$(($test_fixed+1))
217 say_color "" " FIXED $test_count: $@"
220 test_known_broken_failure_ () {
221 test_count=$(expr "$test_count" + 1)
222 test_broken=$(($test_broken+1))
223 say_color skip " still broken $test_count: $@"
226 test_debug () {
227 test "$debug" = "" || eval "$1"
230 test_run_ () {
231 eval >&3 2>&4 "$1"
232 eval_ret="$?"
233 return 0
236 test_skip () {
237 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
238 this_test="$this_test.$(expr "$test_count" + 1)"
239 to_skip=
240 for skp in $GIT_SKIP_TESTS
242 case "$this_test" in
243 $skp)
244 to_skip=t
245 esac
246 done
247 case "$to_skip" in
249 say_color skip >&3 "skipping test: $@"
250 test_count=$(expr "$test_count" + 1)
251 say_color skip "skip $test_count: $1"
252 : true
255 false
257 esac
260 test_expect_failure () {
261 test "$#" = 2 ||
262 error "bug in the test script: not 2 parameters to test-expect-failure"
263 if ! test_skip "$@"
264 then
265 say >&3 "checking known breakage: $2"
266 test_run_ "$2"
267 if [ "$?" = 0 -a "$eval_ret" = 0 ]
268 then
269 test_known_broken_ok_ "$1"
270 else
271 test_known_broken_failure_ "$1"
274 echo >&3 ""
277 test_expect_success () {
278 test "$#" = 2 ||
279 error "bug in the test script: not 2 parameters to test-expect-success"
280 if ! test_skip "$@"
281 then
282 say >&3 "expecting success: $2"
283 test_run_ "$2"
284 if [ "$?" = 0 -a "$eval_ret" = 0 ]
285 then
286 test_ok_ "$1"
287 else
288 test_failure_ "$@"
291 echo >&3 ""
294 test_expect_code () {
295 test "$#" = 3 ||
296 error "bug in the test script: not 3 parameters to test-expect-code"
297 if ! test_skip "$@"
298 then
299 say >&3 "expecting exit code $1: $3"
300 test_run_ "$3"
301 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
302 then
303 test_ok_ "$2"
304 else
305 test_failure_ "$@"
308 echo >&3 ""
311 # test_external runs external test scripts that provide continuous
312 # test output about their progress, and succeeds/fails on
313 # zero/non-zero exit code. It outputs the test output on stdout even
314 # in non-verbose mode, and announces the external script with "* run
315 # <n>: ..." before running it. When providing relative paths, keep in
316 # mind that all scripts run in "trash directory".
317 # Usage: test_external description command arguments...
318 # Example: test_external 'Perl API' perl ../path/to/test.pl
319 test_external () {
320 test "$#" -eq 3 ||
321 error >&5 "bug in the test script: not 3 parameters to test_external"
322 descr="$1"
323 shift
324 if ! test_skip "$descr" "$@"
325 then
326 # Announce the script to reduce confusion about the
327 # test output that follows.
328 say_color "" " run $(expr "$test_count" + 1): $descr ($*)"
329 # Run command; redirect its stderr to &4 as in
330 # test_run_, but keep its stdout on our stdout even in
331 # non-verbose mode.
332 "$@" 2>&4
333 if [ "$?" = 0 ]
334 then
335 test_ok_ "$descr"
336 else
337 test_failure_ "$descr" "$@"
342 # Like test_external, but in addition tests that the command generated
343 # no output on stderr.
344 test_external_without_stderr () {
345 # The temporary file has no (and must have no) security
346 # implications.
347 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
348 stderr="$tmp/git-external-stderr.$$.tmp"
349 test_external "$@" 4> "$stderr"
350 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
351 descr="no stderr: $1"
352 shift
353 say >&3 "expecting no stderr from previous command"
354 if [ ! -s "$stderr" ]; then
355 rm "$stderr"
356 test_ok_ "$descr"
357 else
358 if [ "$verbose" = t ]; then
359 output=`echo; echo Stderr is:; cat "$stderr"`
360 else
361 output=
363 # rm first in case test_failure exits.
364 rm "$stderr"
365 test_failure_ "$descr" "$@" "$output"
369 # This is not among top-level (test_expect_success | test_expect_failure)
370 # but is a prefix that can be used in the test script, like:
372 # test_expect_success 'complain and die' '
373 # do something &&
374 # do something else &&
375 # test_must_fail git checkout ../outerspace
378 # Writing this as "! git checkout ../outerspace" is wrong, because
379 # the failure could be due to a segv. We want a controlled failure.
381 test_must_fail () {
382 "$@"
383 test $? -gt 0 -a $? -le 129 -o $? -gt 192
386 # test_cmp is a helper function to compare actual and expected output.
387 # You can use it like:
389 # test_expect_success 'foo works' '
390 # echo expected >expected &&
391 # foo >actual &&
392 # test_cmp expected actual
395 # This could be written as either "cmp" or "diff -u", but:
396 # - cmp's output is not nearly as easy to read as diff -u
397 # - not all diff versions understand "-u"
399 test_cmp() {
400 $GIT_TEST_CMP "$@"
403 # Most tests can use the created repository, but some may need to create more.
404 # Usage: test_create_repo <directory>
405 test_create_repo () {
406 test "$#" = 1 ||
407 error "bug in the test script: not 1 parameter to test-create-repo"
408 owd=`pwd`
409 repo="$1"
410 mkdir -p "$repo"
411 cd "$repo" || error "Cannot setup test environment"
412 "$GIT_EXEC_PATH/git" init "--template=$GIT_EXEC_PATH/templates/blt/" >&3 2>&4 ||
413 error "cannot run git init -- have you built things yet?"
414 mv .git/hooks .git/hooks-disabled
415 cd "$owd"
418 test_done () {
419 trap - EXIT
420 test_results_dir="$TEST_DIRECTORY/test-results"
421 mkdir -p "$test_results_dir"
422 test_results_path="$test_results_dir/${0%-*}-$$"
424 echo "total $test_count" >> $test_results_path
425 echo "success $test_success" >> $test_results_path
426 echo "fixed $test_fixed" >> $test_results_path
427 echo "broken $test_broken" >> $test_results_path
428 echo "failed $test_failure" >> $test_results_path
429 echo "" >> $test_results_path
431 if test "$test_fixed" != 0
432 then
433 say_color pass "fixed $test_fixed known breakage(s)"
435 if test "$test_broken" != 0
436 then
437 say_color error "still have $test_broken known breakage(s)"
438 msg="remaining $(($test_count-$test_broken)) test(s)"
439 else
440 msg="$test_count test(s)"
442 case "$test_failure" in
444 # We could:
445 # cd .. && rm -fr 'trash directory'
446 # but that means we forbid any tests that use their own
447 # subdirectory from calling test_done without coming back
448 # to where they started from.
449 # The Makefile provided will clean this test area so
450 # we will leave things as they are.
452 say_color pass "passed all $msg"
454 test -d "$remove_trash" &&
455 cd "$(dirname "$remove_trash")" &&
456 rm -rf "$(basename "$remove_trash")"
458 exit 0 ;;
461 say_color error "failed $test_failure among $msg"
462 exit 1 ;;
464 esac
467 # Test the binaries we have just built. The tests are kept in
468 # t/ subdirectory and are run in 'trash directory' subdirectory.
469 TEST_DIRECTORY=$(pwd)
470 PATH=$TEST_DIRECTORY/..:$PATH
471 GIT_EXEC_PATH=$(pwd)/..
472 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
473 unset GIT_CONFIG
474 GIT_CONFIG_NOSYSTEM=1
475 GIT_CONFIG_NOGLOBAL=1
476 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
478 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
479 export GITPERLLIB
480 test -d ../templates/blt || {
481 error "You haven't built things yet, have you?"
484 if ! test -x ../test-chmtime; then
485 echo >&2 'You need to build test-chmtime:'
486 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
487 exit 1
490 . ../GIT-BUILD-OPTIONS
492 # Test repository
493 test="trash directory.$(basename "$0" .sh)"
494 test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
495 rm -fr "$test" || {
496 trap - EXIT
497 echo >&5 "FATAL: Cannot prepare test area"
498 exit 1
501 test_create_repo "$test"
502 # Use -P to resolve symlinks in our working directory so that the cwd
503 # in subprocesses like git equals our $PWD (for pathname comparisons).
504 cd -P "$test" || exit 1
506 # test for symbolic link capability
507 ln -s x y 2> /dev/null && test -l y 2> /dev/null || no_symlinks=1
508 rm -f y
510 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
511 for skp in $GIT_SKIP_TESTS
513 to_skip=
514 for skp in $GIT_SKIP_TESTS
516 case "$this_test" in
517 $skp)
518 to_skip=t
519 esac
520 done
521 case "$to_skip" in
523 say_color skip >&3 "skipping test $this_test altogether"
524 say_color skip "skip all tests in $this_test"
525 test_done
526 esac
527 done
529 # Fix some commands on Windows
530 case $(uname -s) in
531 *MINGW*)
532 # Windows has its own (incompatible) sort and find
533 sort () {
534 /usr/bin/sort "$@"
536 find () {
537 /usr/bin/find "$@"
540 esac